"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RootLogger = void 0;
const common_1 = require("@nestjs/common");
const tokens_1 = require("../tokens");
const pino_1 = __importDefault(require("pino"));
const pino_pretty_1 = __importDefault(require("pino-pretty"));
const pino_std_serializers_1 = __importDefault(require("pino-std-serializers"));
const default_logger_service_1 = require("./default-logger-service");
let RootLogger = class RootLogger extends default_logger_service_1.DefaultLoggerService {
    constructor(bootstrapOptions) {
        const colorizedLogs = process.env.ENABLE_COLORIZED_LOGS === 'true';
        const stream = colorizedLogs
            ? (0, pino_pretty_1.default)({
                colorize: true,
                messageKey: 'message',
            })
            : undefined;
        const logger = (0, pino_1.default)({
            name: bootstrapOptions.name,
            version: bootstrapOptions.version,
            level: process.env.LOG_LEVEL ?? 'info',
            messageKey: 'message',
            paths: [
                'req.headers.authorization',
                "req.headers['x-api-key']",
            ],
            serializers: pino_std_serializers_1.default,
            formatters: {
                level: (label) => ({ level: label }),
            },
        }, stream);
        super(logger);
        this.bootstrapOptions = bootstrapOptions;
    }
    get stream() {
        const { instance: rootLogger } = this;
        return {
            write(message) {
                rootLogger.info(message);
            },
        };
    }
};
RootLogger = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(tokens_1.BOOTSTRAP_OPTIONS_TOKEN)),
    __metadata("design:paramtypes", [Object])
], RootLogger);
exports.RootLogger = RootLogger;
//# sourceMappingURL=root-logger.js.map